//revision history:
//Author               Date          CR#          Description
//xiaxd@cn.ibm.com  2008-09-11   RATLC01375412    line#53 - line#77: for mozilla firefox support
//xiaxd@cn.ibm.com  2008-09-11   RATLC00402800    enable replace Image function work on firefox        
//BinBinLi&ShiJin	2013-12-03	 Enhancement42506 Add or delete rows/columns to existing table in RTE
var STATUS_SELECT_IMAGE=50;

var currentSelectedImg = null;

// Updates the current selection and selection range.
function updateSelection() {
	if (!supportRichTextEditing) {
		return false;
	}	
	
	contentWindow = document.getElementById(editorId).contentWindow;
	editorDoc = contentWindow.document;
	
	var tempSelRange;
	var selOffsetStart = 0;
	var selectedText = "";
	var fontName = "";
	var fontSize = "";
	var blockStyle = "";
	var textFlags = 0;
	
	currentSelectedImg = null;
	if (document.all) {
		selection = editorDoc.selection;
		if (selection != null) {
			selectionRange = selection.createRange();
			if (selectionRange != null) {
				if (selection.type != "Control") {
					tempSelRange = selectionRange.duplicate();
				} else {
					setStatus(STATUS_SELECT_CONTROL, null);
					if (selectionRange(0).tagName == "IMG") {
						currentSelectedImg = selectionRange(0);
						imgHTML = currentSelectedImg.parentNode.innerHTML;
						setStatus(STATUS_SELECT_IMAGE, imgHTML);
					} else if (selectionRange(0).tagName == "TABLE") {
						currentSelectedTable = selectionRange(0);
						setStatus(STATUS_SELECT_TABLE, null);
					}
				}
			}
			reformatElementLinks();
		}
	}
	else {
		// TODO: setStatus on a new type of status,
		// STATUS_SELECT_IMAGE
		// pass the imgHTML as parameter
		selection = contentWindow.getSelection();
		if (selection != null) {
			selectionRange = selection.getRangeAt(selection.rangeCount - 1).cloneRange();
	      //check whether it's a image node or not
            var imgNode = null;
			var tableNode = null;
            //start update-RATLC01375412
			//get image node
			if (selectionRange.startContainer && selectionRange.endContainer &&
              selectionRange.startContainer == selectionRange.endContainer &&
              selectionRange.startContainer.nodeType == 1) 
		    {
		    	 setStatus(STATUS_SELECT_CONTROL, null);
				 if (selectionRange.startContainer.tagName == "IMG")
				 {
				   imgNode = selectionRange.startContainer;
				 } else if (selectionRange.endOffset - selectionRange.startOffset == 1 &&
					 selectionRange.startContainer.childNodes[selectionRange.startOffset].tagName == "IMG")
				 {
				   imgNode = selectionRange.startContainer.childNodes[selectionRange.startOffset];
				}
				if (selectionRange.startContainer.tagName == "TD") {
					tableNode = selectionRange.startContainer;
				} else if (selectionRange.endOffset - selectionRange.startOffset == 1 && selectionRange.startContainer.childNodes[selectionRange.startOffset].tagName == "TD") {
					tableNode = selectionRange.startContainer.childNodes[selectionRange.startOffset];
				}
			}
			if ( imgNode != null )
			{
			  	currentSelectedImg = imgNode;
				imgHTML = currentSelectedImg.parentNode.innerHTML;
//				alert("imgHTML = "+imgHTML);
				setStatus(STATUS_SELECT_IMAGE, imgHTML);
			} else if (tableNode != null){
				currentSelectedTable = tableNode;
				while(currentSelectedTable.nodeName != "TABLE") {
					currentSelectedTable = currentSelectedTable.parentNode;
				}
				setStatus(STATUS_SELECT_TABLE, null);
			} else {
			  tempSelRange = selectionRange.cloneRange();
			} 
//end update-RATLC01375412
		}
	}
	if (tempSelRange != null) {
		try {
			if (document.all) {
				if (selectionRange.text) {
					selectedText = selectionRange.text;
				}
				/* for getting selection offset - commented because we can't select the
				 * proper location in the HTML source tab because JTidy's reformatting of the HTML
				var html = getHTML();
	            var tempSelLen = tempSelRange.htmlText.length;			
	            tempSelRange.moveStart('character', -html.length);
	            selOffsetStart = tempSelRange.htmlText.length - tempSelLen;
	            */
				var selParent = tempSelRange.parentElement();
				fontName = tempSelRange.queryCommandValue('fontName');
				fontSize = tempSelRange.queryCommandValue('fontSize');
				blockStyle = tempSelRange.queryCommandValue('formatBlock');
				if (blockStyle == "Normal") {
					if (selParent.className == "quote") {
						blockStyle = "<quote>";
					} else if (selParent.className == "codeSample") {
						blockStyle = "<code>";
					} else {
						blockStyle = "<p>";
					}
				} else if (blockStyle == "Heading 3") {
					blockStyle = "<h3>";
				} else if (blockStyle == "Heading 4") {
					blockStyle = "<h4>";
				} else if (blockStyle == "Heading 5") {
					blockStyle = "<h5>";
				} else if (blockStyle == "" || blockStyle == null) {
					blockStyle = "<p>";
				}
				if (tempSelRange.queryCommandValue('bold') == true) {
					textFlags |= BOLD;
				}
				if (tempSelRange.queryCommandValue('italic') == true) {
					textFlags |= ITALIC;
				}
				if (tempSelRange.queryCommandValue('underline') == true) {
					textFlags |= UNDERLINE;
				}
				if (tempSelRange.queryCommandValue('subscript') == true) {
					textFlags |= SUBSCRIPT;
				}
				if (tempSelRange.queryCommandValue('superscript') == true) {
					textFlags |= SUPERSCRIPT;
				}
				setStatus(STATUS_SELECT_TEXT, /* selOffsetStart + "$" + */
						fontName + "$" + fontSize + "$" + blockStyle + "$" + textFlags + "$" + selectedText);
			} else {
				if (selectionRange != null) {
					selectedText = selectionRange.toString();
				}
				var selParent = selection.focusNode;
				fontName = editorDoc.queryCommandValue('fontName');
				if (fontName == "") {
					fontName = "default";
				}
				fontSize = editorDoc.queryCommandValue('fontSize');
				if (fontSize == "") {
					fontSize = "default";
				}
				blockStyle = editorDoc.queryCommandValue('formatBlock');
				if (blockStyle == "p") {
					if (selParent.parentNode.className == "quote") {
						blockStyle = "<quote>";
					} else if (selParent.parentNode.className == "codeSample") {
						blockStyle = "<code>";
					} else {
						blockStyle = "<p>";
					}
				} else if (blockStyle == "h3") {
					blockStyle = "<h3>";
				} else if (blockStyle == "h4") {
					blockStyle = "<h4>";
				} else if (blockStyle == "h5") {
					blockStyle = "<h5>";
				} else if (blockStyle == "") {
					blockStyle = "<p>";
				}
				if (editorDoc.queryCommandState('bold') == true) {
					textFlags |= BOLD;
				}
				if (editorDoc.queryCommandState('italic') == true) {
					textFlags |= ITALIC;
				}
				if (editorDoc.queryCommandState('underline') == true) {
					textFlags |= UNDERLINE;
				}
				if (editorDoc.queryCommandState('subscript') == true) {
					textFlags |= SUBSCRIPT;
				}
				if (editorDoc.queryCommandState('superscript') == true) {
					textFlags |= SUPERSCRIPT;
				}
				setStatus(STATUS_SELECT_TEXT, /* selOffsetStart + "$" + */
						fontName + "$" + fontSize + "$" + blockStyle + "$" + textFlags + "$" + selectedText);
			}
		} catch (e) { }
	}	

	return true;
}



function moveCursorToTop() {
	if (document.all) {
		var tempRange = editorDoc.body.createTextRange();
		tempRange.collapse();
		tempRange.select();
		tempRange.scrollIntoView();
	} else {
		// TODO: this needs to be tested
		selection = this.window.getSelection();
//		var startContainer = selectionInfo.startContainer;
//		var start = selectionInfo.start;
//		var endContainer = selectionInfo.endContainer;
//		var end = selectionInfo.end;
		var tempRange = document.createRange();
//		tempRange.setStart(startContainer, start);
//		tempRange.setEnd(endContainer, end);
		selection.removeAllRanges();
		selection.addRange(tempRange);
		contentWindow.focus();
	}
}

// adds the given id to the currrently selected img object
// if no img object selected, does nothing
// NB: this will overwrite any id on the img
function addImageMapEditorIdToImg(id) {
	if (document.all) {
		if (currentSelectedImg != null) {
			currentSelectedImg.id = id;
		}
	} else {
		// TODO: firefox implementation
		// first try the IE implementation
		if (currentSelectedImg != null) {
			currentSelectedImg.id = id;
		}
	}
	imgHTML = currentSelectedImg.parentNode.innerHTML;
	setStatus(STATUS_SELECT_IMAGE, imgHTML);
	setStatus(STATUS_MODIFIED, null);
}

//finds img & map objects with given ids and replaces them with
//the given URLs
function replaceImg(imgId, newImgURL, mapId, newMapURL) {
	if (internalUpdateSelection()) {
	     
		var map = editorDoc.getElementById(mapId);
		var img = editorDoc.getElementById(imgId);
		
		// fix map first
		if (map != null) {
			map.outerHTML = newMapURL;
		} else {
			// map did not exist, add it
			var map = editorDoc.createElement("map");
			map.outerHTML = newMapURL;
			if (img != null) {
			    insertAfter(img, newMapURL);
			}
		}
		if (img != null) {
			// found a match
			img.outerHTML = newImgURL;
		}
		// need to get img again because by changing it's outerHTML it's now a new element
		var newimg = editorDoc.getElementById(imgId);
		if (newimg != null) {
			newimg.removeAttribute('id', 0);
		}
		setStatus(STATUS_MODIFIED, null);
	}
}

//for RATLC00402800: for IE/FireFox compatity
function insertAfter(element, html)
{
  //for IE
  if(element.insertAdjacentHTML){
    element.insertAdjacentHTML('afterEnd',html);
  } 
  //for FF
  else {
    var range = element.ownerDocument.createRange();
    var frag;
    range.setStartAfter(element);
    frag = range.createContextualFragment(html);
    element.parentNode.insertBefore(frag, element.nextSibling);
  }
}